Subject: Re: [dhcwg] DHCP_DECLINE question

From: Ralph Droms <[email-masked]>
Date: Tue, 05 Mar 2002 08:33:18 -0500

I agree with Kim and Ted - DHCPDECLINE is defined in RFC2131 to be used in 
the case of an address conflict, and many DHCP servers will mark the 
address in a DHCPDECLINE so that it is not offered again in the future.

If the client decides that the address or other parameters in a DHCPACK are 
not acceptable, the client should respond with a DHCPRELEASE and then 
restart the address assignment process with a DHCPDISCOVER.

- Ralph

At 12:26 PM 2/28/2002 -0500, Kim Kinnear wrote:
>At 06:04 PM 2/27/2002, Burcak Beser wrote:
> >I have a question regarding the use of DHCP_DECLINE message. If the 
> client is choosing a valid DHCP_OFFER using contents of the returned 
> options, and the DHCP SERVER changes the contents of the options while 
> sending the DHCP_ACK message, is it acceptable for client to use 
> DHCP_DECLINE? (The RFC 2131 states that DHCP_DECLINE is issued when the 
> IP address in use.)
>
>         No, it is not. See below.
>
>
> >In other words when a DHCP_DECLINE is received by the DHCP SERVER does 
> this mean that the client detected that the IP address is already used by 
> another entity?
>
>         Yes, and the implication (as well as the explicit
>         direction) is that the DHCP server should not offer this
>         IP address to this client or any other client for at
>         least some time since it has been shown to be "unusable"
>         for DHCP client allocation (because some client (or
>         machine, maybe not a DHCP client) appears to be using it).
>
>         From RFC2131.txt:
>
>4.3.3 DHCPDECLINE message
>
>    If the server receives a DHCPDECLINE message, the client has
>    discovered through some other means that the suggested network
>    address is already in use.  The server MUST mark the network address
>    as not available and SHOULD notify the local system administrator of
>    a possible configuration problem.
>
>
>         If you don't like the IP address, you could use a
>         DHCPRELEASE to give it back.  Of course, you may in that
>         case be offered it next time, but you don't need to take
>         the offer.
>
>         If you just want to give it back, use DHCPRELEASE.
>
>         If you want to give it back and be offered a different IP
>         address from this server, that's a harder question, since
>         the DHCPDECLINE implies that the address isn't usable.
>
>         Cheers -- Kim
>
>
>
>
>
> >-burcak
> >
> >_______________________________________________
> >dhcwg mailing list
> >[email-masked]
> >https://www1.ietf.org/mailman/listinfo/dhcwg
>
>
>_______________________________________________
>dhcwg mailing list
>[email-masked]
>https://www1.ietf.org/mailman/listinfo/dhcwg

_______________________________________________
dhcwg mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/dhcwg

---

From: "Kostur, Andre" <[email-masked]>
Date: Tue, 5 Mar 2002 09:05:21 -0800

Drawback on the RELEASE/DISCOVER method:  wouldn't this just simply send the
client into an infinite loop of DISCOVER/REQUEST/RELEASE sequence?  If the
stuff sent by the server is unacceptable the first time around, why would
the second time be any different?

And, using DECLINE doesn't make it much better (actually has the potential
to make it worse!).  If a client DECLINES an unsuitable ACK because it
doesn't like one of the DHCP options, the server would likely mark that IP
as used.  Then when that client came back, it will likely DECLINE the next
IP that it's given, the DHCP server marks that IP as used too, and so on,
and so on, until that one client has effectively consumed your entire IP
space!

> -----Original Message-----
> From: Ralph Droms [mailto:[email-masked]]
> Sent: Tuesday, March 5, 2002 5:33 AM
> To: Burcak Beser
> Cc: [email-masked]
> Subject: Re: [dhcwg] DHCP_DECLINE question
> 
>

---

From: "Burcak Beser" <[email-masked]>
Date: Thu, 7 Mar 2002 09:40:23 -0800

I believe that right now the DCHP protocol is growing to include more
than just the IP address but to fulfill the name 'Dynamic Host
Configuration'. As with time the distinction between configuration and
provisioning is getting blurred. If you look into the recent DHCP work
you can see this happening we have Relay Agent Options (and suboptions),
User Class Option, Lease Query. It is my impression is that even though
the IP addressing issues are central to the DHCP supplied information
the configuration extends beyond just IP. The real issue is that should
we start to think about correcting/adding to the RFC such that the
protocol would be extended to include more and more
configuration/provisioning syntax. 

In short, even though we do not see any problems today with the DHC
protocol, we need to think ahead.

-burcak

-----Original Message-----
From: Ted Lemon [mailto:[email-masked]]
Sent: Wednesday, March 06, 2002 8:41 PM
To: Ralph Droms
Cc: [email-masked]
Subject: Re: [dhcwg] DHCP_DECLINE question

> In my opinion, a client is within the spec if it sends a DHCPRELEASE 
> immediately after receiving a DHCPACK (for whatever reason).  The 
> DHCPRELEASE will terminate the lease and make the address available
for 
> reassignment without causing the server to mark the address as "not to
be 
> assigned".

True.

> There is still the open question of whether we want to *recommend*
this 
> behavior...

Right.   I'd say we shouldn't, because in all likelihood it's going to 
result in the client looping behavior about which Barr is concerned.
I 
think that we are trying to fix a nonexistant problem here, and the fix 
seems much worse than the problem, particularly since I've never
observed 
the problem happening in real life.

---

From: Ralph Droms <[email-masked]>
Date: Thu, 07 Mar 2002 12:44:07 -0500

So, Burcak - are you volunteering to revise RFC2131 and RFC2132 so we can 
take DHCP to full Internet Standard?

Names of other volunteers will be gladly accepted; as much as I like 
writing DHCP specs, I'd be *real* happy to give someone else a chance...

- Ralph